@echo off & setlocal ENABLEEXTENSIONS
cd %~dp0
date /t >result.log
time /t >>result.log

cls
ipconfig /flushdns
echo --------------------------------
echo    MATRIX Internet Self-Test
echo --------------------------------
call :GetIP ip
echo/IP Address is: %ip%
echo/IP Address is: %ip%>>result.log
call :GetDG dg
echo/Default Gateway is: %dg%
echo/Default Gateway is: %dg%>>result.log
echo --------------------------------
echo -------------------------------->>result.log
ping -n 1 %dg% >nul
If %ErrorLevel% == 0 (
Echo 1.Default gateway ping - Ok
Echo 1.Default gateway ping - Ok>>result.log
) Else (
Echo 1.Default gateway ping - Failure
Echo 1.Default gateway ping - Failure>>result.log
)
ping -n 1 10.242.0.16 >nul
If %ErrorLevel% == 0 (
Echo 2.DNS m3x ping -         Ok
Echo 2.DNS m3x ping -         Ok>>result.log
) Else (
Echo 2.DNS m3x ping -         Failure
Echo 2.DNS m3x ping -         Failure>>result.log
)
ping -n 1 194.50.9.16 >nul
If %ErrorLevel% == 0 (
Echo 3.DNS-2 m3x ping -       Ok
Echo 3.DNS-2 m3x ping -       Ok>>result.log
) Else (
Echo 3.DNS-2 m3x ping -       Failure
Echo 3.DNS-2 m3x ping -       Failure>>result.log
)
ping -n 1 194.50.9.1 >nul
If %ErrorLevel% == 0 (
Echo 4.GW m3x ping -          Ok
Echo 4.GW m3x ping -          Ok>>result.log
) Else (
Echo 4.GW m3x ping -          Failure
Echo 4.GW m3x ping -          Failure>>result.log
)
ping -n 1 8.8.8.8 >nul
If %ErrorLevel% == 0 (
Echo 5.Google DNS ping -      Ok
Echo 5.Google DNS ping -      Ok>>result.log
) Else (
Echo 5.Google DNS ping -      Failure
Echo 5.Google DNS ping -      Failure>>result.log
)
ping -n 1 ya.ru >nul
If %ErrorLevel% == 0 (
Echo 6.ya.ru ping -           Ok
Echo 6.ya.ru ping -           Ok>>result.log
) Else (
Echo 6.ya.ru ping -           Failure
Echo 6.ya.ru ping -           Failure>>result.log
)
echo --------------------------------
echo      Ping loss check...
Set IP=10.242.0.1&Set i=20
For /F %%I In ('Ping -n %i% %IP%^|Find /C "TTL="') Do (If %%I==%i% (Set Result=7.Loss check -           OK) Else (Set Result=7.Loss chrck %i% from %%I     Fail))
Echo %Result%
Echo %Result% >>result.log
chcp 437>nul
echo --------------------------------
echo -------------------------------->>result.log
echo Check DNS-1
echo Check DNS-1 >>result.log
for /F "usebackq skip=1 tokens=2 delims=:" %%i in (`2^>nul nslookup -type^=a ya.ru ^| find /i "Addr"`) do (
echo 8.  OK
echo OK %%i >>result.log
)
echo Check DNS-2
echo Check DNS-2 >>result.log
for /F "usebackq skip=1 tokens=2 delims=:" %%i in (`2^>nul nslookup -type^=a ya.ru 10.242.0.16 ^| find /i "Addr"`) do (
echo 9.  OK
echo OK %%i >>result.log
)
echo Check DNS-3
echo Check DNS-3 >>result.log
for /F "usebackq skip=1 tokens=2 delims=:" %%i in (`2^>nul nslookup -type^=a ya.ru 194.50.9.16 ^| find /i "Addr"`) do (
echo 10. OK
echo OK %%i >>result.log
)
echo --------------------------------
echo -------------------------------->>result.log
tracert -d 10.242.0.16 >>result.log
echo Please wait...
echo -------------------------------->>result.log
tracert -d 8.8.8.8 >>result.log
echo -------------------------------->>result.log
echo Done
chcp 866>nul
goto :EOFILE

:GetIP ip
setlocal ENABLEEXTENSIONS & set "i=0.0.0.0" & set "j="
for /f "tokens=4" %%a in ('route print^|findstr 0.0.0.0.*0.0.0.0') do (
  if not defined j for %%b in (%%a) do set "i=%%b" & set "j=1")
endlocal & set "%1=%i%" & goto :EOF
:GetDG dg
setlocal ENABLEEXTENSIONS & set "g=0.0.0.0" & set "j="
for /f "tokens=3" %%a in ('route print^|findstr 0.0.0.0.*0.0.0.0') do (
  if not defined j for %%b in (%%a) do set "g=%%b" & set "j=1")
endlocal & set "%1=%g%" & goto :EOF

:EOFILE
pause